VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Character Animation-By MartWare-FPS:"
   ClientHeight    =   6810
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   9945
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   454
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   663
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer tmrMain 
      Interval        =   1000
      Left            =   1800
      Top             =   1560
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' use this to boost speed a little
Option Explicit

' direct x objects (see past tutorials for explainations on these)
Dim dx As New DirectX7
Dim dd As DirectDraw4
Dim clip As DirectDrawClipper
Dim d3drm As Direct3DRM3
Dim scene As Direct3DRMFrame3
Dim cam As Direct3DRMFrame3
Dim dev As Direct3DRMDevice3
Dim view As Direct3DRMViewport2
Dim mesh As Direct3DRMMeshBuilder3

' animation variables
Dim animframe As Direct3DRMFrame3 ' frame that holds the animation
Dim anim As Direct3DRMAnimationSet2 ' the actual animation
Dim curframe As Single ' the current frame that the animation is at
Dim mode As Integer ' his mode eg: walking or jumping
Dim gofoward As Boolean ' if moving foward when jumping

' dll calls (see past tutorials for explainations on these)
Private Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Integer

' frames per second variables
Dim lf As Integer ' frames in last second
Dim f As Integer ' current number of frames

' main sub
Private Sub Form_Load()
    
    ' init direct draw & clipper
    Set dd = dx.DirectDraw4Create("")
    Set clip = dd.CreateClipper(0)
    clip.SetHWnd Me.hWnd
    
    ' if you wish to run this in full screen mode then
    ' un-rem the line 2 lines below and set the forms
    ' border style to 0 - None
    'dd.SetDisplayMode 320, 240, 16, 0, DDSDM_DEFAULT
    
    ' init direct 3drm & main frames
    Set d3drm = dx.Direct3DRMCreate()
    Set scene = d3drm.CreateFrame(Nothing)
    Set cam = d3drm.CreateFrame(scene)
    
    ' add light to camera (see past tutorials for explainations on these)
    Dim light As Direct3DRMLight
    Set light = d3drm.CreateLightRGB(D3DRMLIGHT_DIRECTIONAL, 0.8, 0.8, 0.8)
    light.SetUmbra 0.8: light.SetPenumbra 1.1
    cam.AddLight light
    Set light = Nothing
    
    ' add a bit of ambient light to the scene
    scene.AddLight d3drm.CreateLightRGB(D3DRMLIGHT_AMBIENT, 0.5, 0.5, 0.5)
    
    ' make viewport & device | use IID_IDirect3DRGBDevice \/ here \/ if you dont have a 3d card
    Set dev = d3drm.CreateDeviceFromClipper(clip, "IID_IDirect3DHALDevice", Me.ScaleWidth, Me.ScaleHeight)
    dev.SetQuality D3DRMFILL_SOLID + D3DRMLIGHT_ON + D3DRMSHADE_GOURAUD
    dev.SetDither D_TRUE
    Set view = d3drm.CreateViewport(dev, cam, 0, 0, Me.ScaleWidth, Me.ScaleHeight)
    view.SetBack 5000!
    
    ' create the meshbuilder from which we will add faces(walls) to create our world
    Set mesh = d3drm.CreateMeshBuilder()
    mesh.SetPerspective D_TRUE ' texture correction
    scene.AddVisual mesh ' add mesh builder to scene
    
    ' use my excellent make wall sub to add the walls to the meshbuilder :)
    Call MakeWall(d3drm, mesh, -1000, -15, 1000, 1000, -15, 1000, 1000, -15, -1000, -1000, -15, -1000, "Grass", 80, 80, 0, 0, 0) ' grass texture on the floor
    
    ' create frame and animation
    Set animframe = d3drm.CreateFrame(scene) ' create animation frame
    Set anim = d3drm.CreateAnimationSet() ' create animation set
    anim.LoadFromFile App.Path & "\Character.x", 0, D3DRMLOAD_FROMFILE, Nothing, Nothing, animframe ' load animation into frame and animation set
    animframe.AddScale D3DRMCOMBINE_BEFORE, 0.25, 0.25, 0.25 ' scale down to quarter size
    cam.SetPosition scene, 0, 40, -80 ' put camera behind character
    cam.LookAt animframe, scene, D3DRMCONSTRAIN_Z ' make camera look at character
    animframe.AddChild cam ' make the camera follow the character
    
    ' show form before end of load
    Me.Show
    Me.Refresh
    DoEvents
    
    ' start main app loop
    Do While DoEvents()
        
        ' get mode
        If mode = 0 Then
            
            ' check to move
            If GetKeyState(vbKeyUp) < -5 Then animframe.AddTranslation D3DRMCOMBINE_BEFORE, 0, 0, 2: curframe = curframe + 0.25 ' goto next frame
            If GetKeyState(vbKeyDown) < -5 Then animframe.AddTranslation D3DRMCOMBINE_BEFORE, 0, 0, -2: curframe = curframe - 0.25 ' go back a frame
            If GetKeyState(vbKeyLeft) < -5 Then animframe.AddRotation D3DRMCOMBINE_BEFORE, 0, -2, 0, 0.02: cam.AddRotation D3DRMCOMBINE_AFTER, 0, 2, 0, 0.02  ' direct x rotates the camera with the animation so we must rotate it back
            If GetKeyState(vbKeyRight) < -5 Then animframe.AddRotation D3DRMCOMBINE_BEFORE, 0, 2, 0, 0.02: cam.AddRotation D3DRMCOMBINE_AFTER, 0, -2, 0, 0.02  ' direct x rotates the camera with the animation so we must rotate it back
            
            ' check if current frame is too high or low
            If curframe > 20 Then curframe = 0
            If curframe < 0 Then curframe = 20
            
            ' check if going to jump
            If GetKeyState(vbKeySpace) < -5 Then mode = 1: curframe = 21: If GetKeyState(vbKeyUp) < -5 Then gofoward = True Else gofoward = False
            
        ElseIf mode = 1 Then
            
            ' add one frame
            curframe = curframe + 0.1
            
            ' check if bending or jumping
            If curframe < 25 Then
                
                ' move foward a bit if needed
                If gofoward Then animframe.AddTranslation D3DRMCOMBINE_BEFORE, 0, 0, 1
                
            ElseIf curframe < 30 Then
                
                ' move foward a bit if needed
                If gofoward Then animframe.AddTranslation D3DRMCOMBINE_BEFORE, 0, 0, 1.5
                
                ' move up
                animframe.AddTranslation D3DRMCOMBINE_BEFORE, 0, 2, 0
                
            ElseIf curframe < 35 Then
                
                ' move foward a bit if needed
                If gofoward Then animframe.AddTranslation D3DRMCOMBINE_BEFORE, 0, 0, 1.5
                
                ' move down
                animframe.AddTranslation D3DRMCOMBINE_BEFORE, 0, -2, 0
                
            End If
            
            ' check if finished
            If curframe > 35 Then curframe = 0: mode = 0
            
        End If
        
        ' set his current frame
        If curframe > 30 Then anim.SetTime 30 Else anim.SetTime curframe
        
        ' check to rotate camera ' the D3DRMCOMBINE_AFTER bit tells direct x to rotate around the character
        If GetKeyState(vbKeyZ) < -5 Then cam.AddRotation D3DRMCOMBINE_AFTER, 0, 2, 0, 0.02 ' rotate camera left
        If GetKeyState(vbKeyX) < -5 Then cam.AddRotation D3DRMCOMBINE_AFTER, 0, -2, 0, 0.02 ' rotate camera right
        
        ' render the scene
        view.Clear D3DRMCLEAR_ALL
        view.Render scene
        dev.Update
        
        ' say that another frame has been updated
        f = f + 1
        
        ' check to exit
        If GetKeyState(vbKeyEscape) < -5 Then Unload Me: End
        
    Loop
    
End Sub

' make wall sub, no need to understand it just use it!
Private Sub MakeWall(d3drm As Direct3DRM3, mesh As Direct3DRMMeshBuilder3, X1 As Single, Y1 As Single, z1 As Single, x2 As Single, y2 As Single, z2 As Single, x3 As Single, y3 As Single, z3 As Single, x4 As Single, y4 As Single, z4 As Single, TexFile As String, TileX As Single, TileY As Single, r As Single, g As Single, b As Single)
    ' local variables
    Dim f As Direct3DRMFace2
    Dim t As Direct3DRMTexture3
    ' create face
    Set f = d3drm.CreateFace()
    ' add vertexs
    f.AddVertex X1, Y1, z1
    f.AddVertex x2, y2, z2
    f.AddVertex x3, y3, z3
    f.AddVertex x4, y4, z4
    ' get type of file
    If TexFile = "" Then
        ' set colors
        f.SetColorRGB r, g, b
    Else
        ' create textuere
        Set t = d3drm.LoadTexture(App.Path & "\" & TexFile & ".bmp")
        ' set u and v values
        f.SetTextureCoordinates 0, 0, 0
        f.SetTextureCoordinates 1, TileX, 0
        f.SetTextureCoordinates 2, TileX, TileY
        f.SetTextureCoordinates 3, 0, TileY
        ' set the texture
        f.SetTexture t
    End If
    ' add face to mesh
    mesh.AddFace f
End Sub

' frames per second timer
Private Sub tmrMain_Timer()
    
    ' set last fps
    lf = f
    
    ' reset fps
    f = 0
    
    ' show fps
    Me.Caption = "Camera Movements-By MartWare-FPS: " & Trim(Str(lf))
    
End Sub
